--
--Universal 1010 DT
--
--
-- Script Specializat Pentru Universal 1010 DT
--
-- @Autor: Mihai94
-- @Data: 06/06/2015
-- Versiunea: 1.0
--loadFromAttributesAndNodes
--
-- A Nu Se Modifica Fara Permisiunea Mea...
--

UTB1010DT = {};

function UTB1010DT.prerequisitesPresent(specializations)
     print("......INCARCA SCRIPTUL PENTRU UTB 1010 DT BY MIHAI94......");
	return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function UTB1010DT:load(xmlFile)
    self.isSelectabil = true
	self.armNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.characterNode#armIndex"));
	self.backcamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backcamera#index"));
	
	-- Lumini Tractor
	self.numHeadLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.headLights#count"), 0);
    self.headLights = {};
    for i=1, self.numHeadLights do
        local headLightsNamei = string.format("vehicle.headLights.headLight" .. "%d", i);
        self.headLights[i] = Utils.indexToObject(self.components, getXMLInt(xmlFile, headLightsNamei .. "#index"));
        setVisibility(self.headLights[i], false);
    end;

	self.numFrontWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontWorkLights#count"), 0);
    self.frontWorkLights = {};
    for i=1, self.numFrontWorkLights do
        local frontWorkLightsNamei = string.format("vehicle.frontWorkLights.frontWorkLight" .. "%d", i);
        self.frontWorkLights[i] = Utils.indexToObject(self.components, getXMLInt(xmlFile, frontWorkLightsNamei .. "#index"));
        setVisibility(self.frontWorkLights[i], false);
    end;
	
	self.numWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.workLights#count"), 0);
    self.workLights = {};
    for i=1, self.numWorkLights do
        local workLightsNamei = string.format("vehicle.workLights.workLight" .. "%d", i);
        self.workLights[i] = Utils.indexToObject(self.components, getXMLInt(xmlFile, workLightsNamei .. "#index"));
        setVisibility(self.workLights[i], false);
    end;
	self.frontLightMode = 0;
	self.headLightActive = false;
	self.frontWorkLightActive = false;
	self.workLightActive = false;
	self.lightSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lightSwitch#index"));
	
	-- animatii capete de bara /cilindri
	self.cylinders = {};
	local i = 0;
	while true do
		local nameStr = string.format("vehicle.CilindriHidraulici.CilindriHidraulici(%d)", i);
        local cylinder = {};
        local cylinderStr = getXMLString(xmlFile, nameStr .. "#cylinder");
        if cylinderStr == nil then
            break;
        end;
        cylinder.index = Utils.indexToObject(self.components, cylinderStr);
        cylinder.directionFix = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#cylinderFix"));
		cylinder.punch = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#punch"));
		if cylinder.punch ~= nil then
			cylinder.translationFix = Utils.indexToObject(self.components, getXMLString(xmlFile, nameStr .. "#punchFix"));
			local ax, ay, az = getWorldTranslation(cylinder.punch);
			local bx, by, bz = getWorldTranslation(cylinder.translationFix);		
			cylinder.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
		cylinder.scalePunch = Utils.getNoNil(getXMLBool(xmlFile, nameStr .. "#scale"), false);
		table.insert(self.cylinders, cylinder);
		i = i + 1;
	end;
	
	-- animatii brat hidraulic
	self.hh = {};
	self.hh.arm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicAnimation.backArm#index"));
	self.hh.armGetRot = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicAnimation.backArm#getRotRef"));
	self.hh.streben = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicAnimation.streben#index"));
	self.hh.strebenRefPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicAnimation.streben#refPoint"));
	self.hh.strebenScaleRefPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicAnimation.streben#scaleRefPoint"));
	self.hh.strebenDoScale = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.hydraulicAnimation.streben#doScaleBool"), false);
	
	ax, ay, az = getWorldTranslation(self.hh.streben);
    bx, by, bz = getWorldTranslation(self.hh.strebenScaleRefPoint);
    self.hh.strebenDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);	
	
	self.hh.zylinder = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicAnimation.zylinder#index"));
	self.hh.stempel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicAnimation.zylinder#stempelIndex"));
	
	--cardan tractiune 4x4
	self.cShafts = {};		
	local i = -1;
	while true do
		i = i + 1;
		local index = getXMLString(xmlFile, string.format('vehicle.CardanTractiune4X4.shaft(%d)#index', i));
		if index == nil then break; end;
		local cs = {};
		cs.idx = Utils.indexToObject(self.components, index);
		cs.spd = getXMLFloat(xmlFile, string.format('vehicle.CardanTractiune4X4.shaft(%d)#speed', i));
		table.insert(self.cShafts, cs);
	end;
	
	-- Animatii Interior
	local rotationPartNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPlug#index"));
    if rotationPartNode1 ~= nil then
        self.rotationPart1 = {};
        self.rotationPart1.node = rotationPartNode1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPlug#minRot"));
        self.rotationPart1.minRot = {};
        self.rotationPart1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPlug#maxRot"));
        self.rotationPart1.maxRot = {};
        self.rotationPart1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPlug#rotTime"), 2)*1000;
    end;
	local rotationPartNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.Acceleratie#index"));
    if rotationPartNode2 ~= nil then
        self.rotationPart2 = {};
        self.rotationPart2.node = rotationPartNode2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Acceleratie#minRot"));
        self.rotationPart2.minRot = {};
        self.rotationPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Acceleratie#maxRot"));
        self.rotationPart2.maxRot = {};
        self.rotationPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.Acceleratie#rotTime"), 2)*1000;
    end;
	local rotationPartNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.Ambreiaj#index"));
    if rotationPartNode3 ~= nil then
        self.rotationPart3 = {};
        self.rotationPart3.node = rotationPartNode3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Ambreiaj#minRot"));
        self.rotationPart3.minRot = {};
        self.rotationPart3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Ambreiaj#maxRot"));
        self.rotationPart3.maxRot = {};
        self.rotationPart3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.Ambreiaj#rotTime"), 2)*1000;
    end;
	local rotationPartNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.Frana#index"));
    if rotationPartNode4 ~= nil then
        self.rotationPart4 = {};
        self.rotationPart4.node = rotationPartNode4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Frana#minRot"));
        self.rotationPart4.minRot = {};
        self.rotationPart4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Frana#maxRot"));
        self.rotationPart4.maxRot = {};
        self.rotationPart4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.Frana#rotTime"), 2)*1000;
    end;
	local rotationPartNode5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.AcceleratieMana#index"));
    if rotationPartNode5 ~= nil then
        self.rotationPart5 = {};
        self.rotationPart5.node = rotationPartNode5;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.AcceleratieMana#minRot"));
        self.rotationPart5.minRot = {};
        self.rotationPart5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.AcceleratieMana#maxRot"));
        self.rotationPart5.maxRot = {};
        self.rotationPart5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
	
	end;
	local rotationPartNode6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaDisc#index"));
    if rotationPartNode6 ~= nil then
        self.rotationPart6 = {};
        self.rotationPart6.node = rotationPartNode6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaDisc#minRot"));
        self.rotationPart6.minRot = {};
        self.rotationPart6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaDisc#maxRot"));
        self.rotationPart6.maxRot = {};
        self.rotationPart6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaDisc#rotTime"), 2)*1000;
		self.lightsOn = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.Led1#decoration"));
    end;
	local rotationPartNode8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPriza#index"));
    if rotationPartNode8 ~= nil then
        self.rotationPart8 = {};
        self.rotationPart8.node = rotationPartNode8;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPriza#minRot"));
        self.rotationPart8.minRot = {};
        self.rotationPart8.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart8.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart8.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPriza#maxRot"));
        self.rotationPart8.maxRot = {};
        self.rotationPart8.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart8.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart8.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart8.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.ManetaPriza#rotTime"), 2)*1000;
    end;
	
	self.numberImplements = 0;
	self.hasNeedles = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.UTB1010DT#hasNeedle"), false);
	local rotationPartFuel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.Combustibil#index"));
    if rotationPartFuel ~= nil then
        self.rotationFuel = {};
        self.rotationFuel.node = rotationPartFuel;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Combustibil#minRot"));
        self.rotationFuel.minRot = {};
        self.rotationFuel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationFuel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationFuel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Combustibil#maxRot"));
        self.rotationFuel.maxRot = {};
        self.rotationFuel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationFuel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationFuel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
	end;
	
	local rotationPartNode9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.AerButelie#index"));
    if rotationPartNode9 ~= nil then
        self.rotationPart9 = {};
        self.rotationPart9.node = rotationPartNode9;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.AerButelie#minRot"));
        self.rotationPart9.minRot = {};
        self.rotationPart9.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart9.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart9.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.AerButelie#maxRot"));
        self.rotationPart9.maxRot = {};
        self.rotationPart9.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart9.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart9.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart9.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.AerButelie#rotTime"), 2)*1000;
    end;
	local rotationPartNode10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.TemperaturaApa#index"));
    if rotationPartNode10 ~= nil then
        self.rotationPart10 = {};
        self.rotationPart10.node = rotationPartNode10;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.TemperaturaApa#minRot"));
        self.rotationPart10.minRot = {};
        self.rotationPart10.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart10.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart10.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.TemperaturaApa#maxRot"));
        self.rotationPart10.maxRot = {};
        self.rotationPart10.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart10.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart10.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart10.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.TemperaturaApa#rotTime"), 2)*1000;
    end;
	local rotationPartNode11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.Presiune#index"));
    if rotationPartNode11 ~= nil then
        self.rotationPart11 = {};
        self.rotationPart11.node = rotationPartNode11;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Presiune#minRot"));
        self.rotationPart11.minRot = {};
        self.rotationPart11.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart11.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart11.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.UTB1010DT.Presiune#maxRot"));
        self.rotationPart11.maxRot = {};
        self.rotationPart11.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart11.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart11.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart11.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.UTB1010DT.Presiune#rotTime"), 2)*1000;
    end;
	
	-- Animatii Motor
	  self.Ventilator = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.Ventilator#index"));
      self.FulieAlternator = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.FulieAlternator#index"));
      self.FulieArbore = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.FulieArbore#index"));
	  self.FulieCompresor = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.UTB1010DT.FulieCompresor#index"));
	  
	  -- camera pasager
	  -- Set passenger function
	self.setPassenger = SpecializationUtil.callSpecializationsFunction("setPassenger");

	-- Nickname rendernode
	self.passengerFarmerNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.passengerFarmerNode#index"));
	self.passengerNicknameRenderNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.passengerNicknameRenderNode#index"));
	self.passengerNicknameRenderNodeOffset = {0,0,0};

	-- The passenger. He is the passenger, he rides and he rides.
	self.passengerPlayer = nil;

	-- The passengers name
	self.passengerName = "";

	-- Passenger cameras. Yes, there can be more then two, but that requires modifications in the script.
	self.passengerCameras = {};

	local passengerCameraName = string.format("vehicle.passengerCamera");
	local passengerCamera = VehicleCamera:new(self);

	if passengerCamera:loadFromXML(xmlFile, passengerCameraName) then
		table.insert(self.passengerCameras, passengerCamera);
	end;

	-- Variable for inrangecheck
	self.inRangeOfVehicle = false;

	-- Variable to check if user is chatting, to prevent exit on InputBinding.ENTER-event
	self.isChatting = false;
	
	self.PlayerAttach = {};
	setVisibility(self.passengerFarmerNode,false);
	
	end;

function UTB1010DT:postLoad(xmlFile)
	if self.armNode ~= nil then
		setVisibility(self.armNode, false);
	end;
end;

function UTB1010DT:delete()
-- camera pasager
for _, passengerCamera in ipairs(self.passengerCameras) do
		passengerCamera:delete();
	end;
end;

function UTB1010DT:readStream(streamId, connection)
-- camera pasager
local passengerPlayerId = streamReadInt32(streamId);
	self.passengerName = streamReadString(streamId);

	if passengerPlayerId ~= -1 then
		self.passengerPlayer = networkGetObject(passengerPlayerId);
	end;
end;

function UTB1010DT:writeStream(streamId, connection)
-- camera pasager
if self.passengerPlayer ~= nil then
		streamWriteInt32(streamId, networkGetObjectId(self.passengerPlayer));
	else
		streamWriteInt32(streamId, -1);
	end;
	streamWriteString(streamId, self.passengerName);
end;

function UTB1010DT:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
end;

function UTB1010DT:getSaveAttributesAndNodes(nodeIdent)
end;

function UTB1010DT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function UTB1010DT:keyEvent(unicode, sym, modifier, isDown)
end;

function UTB1010DT:update(dt)
-- animatii Motor
if self.isMotorStarted then
         rotate(self.Ventilator, 0, 0, dt*0.01 );
         rotate(self.FulieAlternator, 0, 0, dt*0.01 );	
         rotate(self.FulieArbore, 0, 0, dt*0.01 );	
rotate(self.FulieCompresor, 0, 0, dt*0.01 );		 
	end;

-- camera spate
if self.isEntered then
        if Input.isKeyPressed(Input.KEY_lshift) then
                setCamera(self.backcamera);
       	end;
     end;

-- animatii brat hidraulic
if self:getIsActive() then
		if self.hh ~= nil then
			-- Rotation des Hydraulikarmes --
			if self.hh.arm ~= nil then
				local rotx, roty, rotz = getRotation(self.hh.armGetRot);
				setRotation(self.hh.arm, rotx, roty, rotz);
			end;
			-- Ausrichtung der Streben --
			if self.hh.streben ~= nil then
				local ax, ay, az = getWorldTranslation(self.hh.streben);
				local bx, by, bz = getWorldTranslation(self.hh.strebenRefPoint);
				x, y, z = worldDirectionToLocal(getParent(self.hh.streben), bx-ax, by-ay, bz-az);
				setDirection(self.hh.streben, x, y, z, 0, 0, 1);
			    -- Skalierung der Streben für Korrektes aussehen IG, abgeguggt bei SFM's 09er GTA, thx...  --				
				if self.hh.strebenDoScale == true then
					local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
					local scaleX, scaleY, scaleZ = getScale(self.hh.streben);
					local setScaleWert = scaleZ * (distance / self.hh.strebenDistance);
					setScale(self.hh.streben, 1, 1, setScaleWert);
			    end;
			end;
			-- Ausrichtung des Zylinders und des Stempels --
			if self.hh.zylinder ~= nil and self.hh.stempel ~= nil then
				local a2x, a2y, a2z = getWorldTranslation(self.hh.zylinder);
				local b2x, b2y, b2z = getWorldTranslation(self.hh.stempel);
				x2, y2, z2 = worldDirectionToLocal(getParent(self.hh.zylinder), b2x-a2x, b2y-a2y, b2z-a2z);
				setDirection(self.hh.zylinder, x2, y2, z2, 0, 0, 1);			
				local a3x, a3y, a3z = getWorldTranslation(self.hh.stempel);
				local b3x, b3y, b3z = getWorldTranslation(self.hh.zylinder);
				x3, y3, z3 = worldDirectionToLocal(getParent(self.hh.stempel), b3x-a3x, b3y-a3y, b3z-a3z);
				setDirection(self.hh.stempel, x3, y3, z3, 0, 0, 1);
			end;
		end;
	end;
	
	-- Animatii Interior
	if self:getIsActive() then
		if self.rotationPart1 ~= nil then
			if self.selectedImplement ~= 0 then				
				for k,implement in pairs(self.attachedImplements) do
					local jointIndex = implement.jointDescIndex;
					if jointIndex == 1 and implement.object.allowsLowering then
						if implement.object:isLowered(false) then
							self.liftArmsLever = true;
						else
							self.liftArmsLever = false;
						end;
					else
						if self.trailerAttached then
							self.liftArmsLever = true;
						else
							self.liftArmsLever = false;
						end;							
					end;
				end;
			end;
			local x, y, z = getRotation(self.rotationPart1.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart1.maxRot, self.rotationPart1.minRot, 3, self.rotationPart1.rotTime, dt, not self.liftArmsLever);
			setRotation(self.rotationPart1.node, unpack(newRot));
		end;
		
		local maxhandthrottle = 1500;
		if self.rotationPart2 ~= nil and self.isMotorStarted == true then
			local x, y, z = getRotation(self.rotationPart2.node);
			x = ((self.rotationPart2.maxRot[1] - self.rotationPart2.minRot[1]) / maxhandthrottle) * (self.motor.lastMotorRpm/1.5) + self.rotationPart2.minRot[1];
			y = ((self.rotationPart2.maxRot[2] - self.rotationPart2.minRot[2]) / maxhandthrottle) * (self.motor.lastMotorRpm/1.5) + self.rotationPart2.minRot[2];
			z = ((self.rotationPart2.maxRot[3] - self.rotationPart2.minRot[3]) / maxhandthrottle) * (self.motor.lastMotorRpm/1.5) + self.rotationPart2.minRot[3];
			setRotation(self.rotationPart2.node, x, y ,z);
		elseif self.isMotorStarted == false then
			setRotation(self.rotationPart2.node, self.rotationPart2.minRot[1], self.rotationPart2.minRot[2], self.rotationPart2.minRot[3]);
		end;
		
		if self.rotationPart3 ~= nil then
			local x, y, z = getRotation(self.rotationPart3.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart3.maxRot, self.rotationPart3.minRot, 3, self.rotationPart3.rotTime, dt, self.brakeLightsVisibility);
			setRotation(self.rotationPart3.node, unpack(newRot));
		end;
		
		if self.rotationPart4 ~= nil then
			local x, y, z = getRotation(self.rotationPart4.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart4.maxRot, self.rotationPart4.minRot, 3, self.rotationPart4.rotTime, dt, self.brakeLightsVisibility);
			setRotation(self.rotationPart4.node, unpack(newRot));
		end;
		
		if self.rotationPart5 ~= nil and self.rotLeverPercent ~= nil then
			local maxRot = (self.rotationPart5.maxRot[1] - self.rotationPart5.minRot[1]), (self.rotationPart5.maxRot[2] - self.rotationPart5.minRot[2]), (self.rotationPart5.maxRot[3] - self.rotationPart5.minRot[3]);
			local newRot = maxRot*(self.rotLeverPercent/100);
			setRotation(self.rotationPart5.node, newRot);
		end;
		
		if self.rotationPart6 ~= nil then
			self.isLightsOn = getVisibility(self.lightsOn);
			local x, y, z = getRotation(self.rotationPart6.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart6.maxRot, self.rotationPart6.minRot, 3, self.rotationPart6.rotTime, dt, not self.isLightsOn);
			setRotation(self.rotationPart6.node, unpack(newRot));
		end;
		
		if self.rotationPart8 ~= nil then
			if self.numberImplements > 0 then
				for k,implement in pairs(self.attachedImplements) do
					if implement.object.isTurnedOn then
						self.operatePTOLever = true;
					else
						self.operatePTOLever = false;
					end;
				end;
			else
				self.operatePTOLever = false;		
			end;
			local x, y, z = getRotation(self.rotationPart8.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart8.maxRot, self.rotationPart8.minRot, 3, self.rotationPart8.rotTime, dt, not self.operatePTOLever);
			setRotation(self.rotationPart8.node, unpack(newRot));
		end;
		
		if self.hasNeedles then
			if self.isMotorStarted then
				local x, y, z = getRotation(self.rotationFuel.node);
				x = (self.rotationFuel.maxRot[1] - self.rotationFuel.minRot[1]) * (self.fuelFillLevel/self.fuelCapacity);
				y = (self.rotationFuel.maxRot[2] - self.rotationFuel.minRot[2]) * (self.fuelFillLevel/self.fuelCapacity);
				z = (self.rotationFuel.maxRot[3] - self.rotationFuel.minRot[3]) * (self.fuelFillLevel/self.fuelCapacity);
				setRotation(self.rotationFuel.node, x, y, z);
				self.operateNeedles = true;
				if not self.isHired then
					self.steeringEnabled = true;
				end;
			else
				setRotation(self.rotationFuel.node, self.rotationFuel.minRot[1], self.rotationFuel.minRot[2], self.rotationFuel.minRot[3]);
				self.operateNeedles = false;
				if not self.isHired then
					self.steeringEnabled = false;
				end;
			end;
			
			local x, y, z = getRotation(self.rotationPart9.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart9.maxRot, self.rotationPart9.minRot, 3, self.rotationPart9.rotTime, dt, not self.operateNeedles);
			setRotation(self.rotationPart9.node, unpack(newRot));
			
			local x, y, z = getRotation(self.rotationPart10.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart10.maxRot, self.rotationPart10.minRot, 3, self.rotationPart10.rotTime, dt, not self.operateNeedles);
			setRotation(self.rotationPart10.node, unpack(newRot));
			
			local x, y, z = getRotation(self.rotationPart11.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart11.maxRot, self.rotationPart11.minRot, 3, self.rotationPart11.rotTime, dt, not self.operateNeedles);
			setRotation(self.rotationPart11.node, unpack(newRot));
		end;
		
		-- camera pasager
		if self.passengerPlayer ~= nil then
		-- if player joins a vehicle, set passenger-spot not taken!
		if not self.passengerPlayer.isControlled and not self.passengerPlayer.isEntered then
			if self.passengerPlayer == g_currentMission.player then
				g_currentMission.isPlayerFrozen = false;
			end;
			self:setPassenger("ExitedToOtherVehicle", nil);
			return;
		end;
	end;
	-- Manage key events for inrange --
	if self.inRangeOfVehicle and self.passengerPlayer == nil and self.isControlled and g_settingsNickname ~= self.controllerName then
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("ENTER_PASSENGERSEAT"), self.typeDesc), InputBinding.ENTER);
		if InputBinding.hasEvent(InputBinding.ENTER) then   
			self:setPassenger(g_settingsNickname, g_currentMission.player);
			g_currentMission.hasSpecialCamera = true;
			self.passengerCameras[1]:onActivate();
			g_currentMission.hasSpecialCamera = true;
			self.passengerPlayer.rotX = 0;
			self.passengerPlayer.rotY = 180;
			return;
		end;
	end;
	if self.passengerPlayer ~= nil then
		if self.passengerPlayer ~= nil then
			if g_currentMission:getIsServer() then
				if g_currentMission.connectionsToPlayer[self.passengerPlayer.creatorConnection] == nil then
					self:setPassenger("Disconnected", nil);
					return;
				end;
			end;
		end;
		self.passengerCameras[1]:update(dt);
		if self.passengerName == g_settingsNickname then
			if InputBinding.hasEvent(InputBinding.CHAT) and not self.isChatting then
				self.isChatting = true;
			end;
			if InputBinding.hasEvent(InputBinding.MENU_ACCEPT) and self.isChatting then
				self.isChatting = false;
			end;
			local inputZ = InputBinding.getDigitalInputAxis(InputBinding.AXIS_LOOK_LEFTRIGHT_PLAYER)
			local inputW = InputBinding.getDigitalInputAxis(InputBinding.AXIS_LOOK_UPDOWN_PLAYER)
			if InputBinding.isAxisZero(inputZ) then
			  inputZ = InputBinding.getAnalogInputAxis(InputBinding.AXIS_LOOK_LEFTRIGHT_PLAYER)
			end
			if InputBinding.isAxisZero(inputW) then
			  inputW = InputBinding.getAnalogInputAxis(InputBinding.AXIS_LOOK_UPDOWN_PLAYER)
			end
			local rotSpeed = 0.001 * dt
			self.passengerPlayer.rotX = self.passengerPlayer.rotX - rotSpeed * inputW
			self.passengerPlayer.rotY = self.passengerPlayer.rotY - rotSpeed * inputZ
			self.passengerPlayer.rotX = math.min(1.2, math.max(-1.5, self.passengerPlayer.rotX))
			setRotation(self.passengerPlayer.cameraId, self.passengerPlayer.rotX, 0, 0)
			setRotation(self.passengerPlayer.graphicsRootNode, 0, self.passengerPlayer.rotY, 0)
			if self.passengerPlayer ~= nil and self.passengerPlayer.cameraId ~= nil and self.passengerPlayer.graphicsRootNode ~= nil then
				local pcx, pcy, pcz = getRotation(self.passengerPlayer.cameraId);
				local prx, pry, prz = getRotation(self.passengerPlayer.graphicsRootNode);
				setRotation(self.passengerCameras[1].cameraNode, pcx, (pry+180), 0);
			end;
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("EXIT_PASSENGERSEAT"), self.typeDesc), InputBinding.ENTER);
			if InputBinding.hasEvent(InputBinding.ENTER) and not self.isChatting then
				g_currentMission.hasSpecialCamera = false;
				self.passengerCameras[1]:onDeactivate();
				g_currentMission.hasSpecialCamera = false;
				setCamera(self.passengerPlayer.cameraId);
				g_currentMission.hasSpecialCamera = false;
				g_currentMission.isPlayerFrozen = false;
				self:setPassenger("Exited", nil);
			end;
		else
			setVisibility(self.passengerFarmerNode,true);
		end;
	end;
	
end;

function UTB1010DT:updateTick(dt)
-- Lumini Tractor
if self.isEntered then
		if InputBinding.hasEvent(InputBinding.AprindeLuminile) then
			self.frontLightMode = self.frontLightMode + 1;
			if self.frontLightMode > 5 then
				self.frontLightMode = 0;
			end;
		end;

if self.frontLightMode == 0  then
		self.headLightActive = false;
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(0), 0);
		end;
	elseif self.frontLightMode == 1 or self.frontLightMode == 5 then
		self.headLightActive = true;
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 30, Utils.degToRad(0), 0);
		end;
	elseif self.frontLightMode == 2 or self.frontLightMode == 4 then
		self.headLightActive = true;
		self.workLightActive = false;
		self.frontWorkLightActive = true;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 60, Utils.degToRad(0), 0);
		end;
	elseif self.frontLightMode == 3 then
		self.headLightActive = true;
		self.workLightActive = true;
		self.frontWorkLightActive = true;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 90, Utils.degToRad(0), 0);
		end;
	end;
	
	for i=1, self.numHeadLights do
		setVisibility(self.headLights[i], self.headLightActive);
	end;
	
	for i=1, self.numFrontWorkLights do
		setVisibility(self.frontWorkLights[i], self.frontWorkLightActive);
	end;
	
	for i=1, self.numWorkLights do
		setVisibility(self.workLights[i], self.workLightActive);
	end;

--animatii capete de bara/cilindri
for _, cylinder in pairs(self.cylinders) do
		local ax, ay, az = getWorldTranslation(cylinder.index);
		local bx, by, bz = getWorldTranslation(cylinder.directionFix);
		local x, y, z = worldDirectionToLocal(getParent(cylinder.index), bx-ax, by-ay, bz-az);
		local xU, yU, zU = 0, 1, 0;
		if math.abs(y) > 0.99 * Utils.vector3Length(x, y, z) then
			yU = 0;
			if y > 0 then
				zU = 1;
			else
				zU = -1;
			end;
		end;
		setDirection(cylinder.index, x, y, z, xU, yU, zU);
		if cylinder.punchDistance ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			if cylinder.scalePunch then
				local xS, yS, zS = getScale(cylinder.punch);
				local newS = xS * (distance / cylinder.punchDistance);
				setScale(cylinder.punch, xS, yS, newS);
			else
				setTranslation(cylinder.punch, 0, 0, distance-cylinder.punchDistance);
			end;
		end;
	end;
	
	-- cardan cuplare 4x4
	local x,y,z = getRotation(self.wheels[1].driveNode);
	for i,shaft in pairs(self.cShafts) do
		setRotation(shaft.idx, x*shaft.spd, 0 ,0);			
	end;
	
	-- camera pasager
	if g_currentMission.player ~= nil then
		-- Getting the distance between the player and the implement
		local nearestDistance = 4.0; --max distance allowed
		local px, py, pz = getWorldTranslation(self.rootNode);
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			self.inRangeOfVehicle = true;
		else
			self.inRangeOfVehicle = false;
		end;
	end;

end;

function UTB1010DT:draw()	
-- camera pasager
-- Renders the passenger name for everyone except the passenger
	if g_settingsNickname ~= nil then
		if self.passengerName ~= g_settingsNickname and self.isControlled and self.passengerPlayer ~= nil and g_gui.currentGui == nil then
			local x,y,z = getWorldTranslation(self.passengerNicknameRenderNode);
			local x1,y1,z1 = getWorldTranslation(getCamera())
			local distSq = Utils.vector3LengthSq(x-x1,y-y1,z-z1);
			if distSq <= 100*100 then
				x = x + self.passengerNicknameRenderNodeOffset[1];
				y = y + self.passengerNicknameRenderNodeOffset[2];
				z = z + self.passengerNicknameRenderNodeOffset[3];
				local sx,sy,sz = project(x,y,z);
				if sz <= 1 then
					setTextAlignment(RenderText.ALIGN_CENTER);
					setTextBold(false);
					setTextColor(0.0, 0.0, 0.0, 0.75);
					renderText(sx, sy-0.0015, 0.02, self.passengerName);

					setTextColor(0.5, 1.0, 0.5, 1.0);
					renderText(sx, sy, 0.02, self.passengerName);

					setTextAlignment(RenderText.ALIGN_LEFT);
				end;
			end;
		end;
	end;
end;

function UTB1010DT:onEnter()
	if self.armNode ~= nil then
		setVisibility(self.armNode, true);
	end;
end;

function UTB1010DT:onLeave()
	if self.armNode ~= nil then
		if self.disableCharacterOnLeave then
			setVisibility(self.armNode, false);
		else
			setVisibility(self.armNode, true);
		end;
	end;
end;

function UTB1010DT:setPassenger(passengerName, passengerPlayer, noEventSend)
	SetPassengerEvent.sendEvent(self, passengerName, passengerPlayer, noEventSend);
	if passengerPlayer ~= nil then
		local x,y,z = getWorldTranslation(self.passengerFarmerNode);
		passengerPlayer:moveToAbsolute(x,(y-500),z);
		setTranslation(passengerPlayer.rootNode,x,(y-500),z);
		if self.HoldAtVehiclePlayer == g_currentMission.player then
			g_currentMission.isPlayerFrozen = true;
		end;
		self.passengerName = passengerName;
	elseif passengerName == "Exited" then
		self.passengerPlayer:moveToExitPoint(self);
		self.passengerName = "";
		setVisibility(self.passengerFarmerNode,false);
	else
		self.passengerName = "";
		setVisibility(self.passengerFarmerNode,false);
	end;

	self.passengerPlayer = passengerPlayer;
end;

-- Passenger on enter event-class
SetPassengerEvent = {};
SetPassengerEvent_mt = Class(SetPassengerEvent, Event);

--InitEventClass(SetPassengerEvent, "SetPassengerEvent");

function SetPassengerEvent:emptyNew()
	local self = Event:new(SetPassengerEvent_mt);
	self.className="SetPassengerEvent";
	return self;
end;

function SetPassengerEvent:new(vehicle, passengerName, passengerPlayer)
	local self = SetPassengerEvent:emptyNew()
	self.vehicle = vehicle;
	self.passengerName = passengerName;
	self.passengerPlayer = passengerPlayer;
	return self;
end;

function SetPassengerEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	local passengerPlayerId = streamReadInt32(streamId);
	self.passengerName = streamReadString(streamId);

	self.vehicle = networkGetObject(id);
	self.passengerPlayer = networkGetObject(passengerPlayerId);
	self:run(connection);
end;

function SetPassengerEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt32(streamId, networkGetObjectId(self.passengerPlayer));
	streamWriteString(streamId, self.passengerName);
end;

function SetPassengerEvent:run(connection)
	self.vehicle:setPassenger(self.passengerName, self.passengerPlayer, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetPassengerEvent:new(self.vehicle, self.passengerName, self.passengerPlayer), nil, connection, self.vehicle);
	end;
end;

function SetPassengerEvent.sendEvent(vehicle, passengerName, passengerPlayer, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetPassengerEvent:new(vehicle, passengerName, passengerPlayer), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetPassengerEvent:new(vehicle, passengerName, passengerPlayer));
		end;
	end;
end;
end;
end;